org.icefaces.ace.component.menubutton

## Class MenuButtonBase

- java.lang.Object
- - javax.faces.component.UIComponent
  - - javax.faces.component.UIComponentBase
    - - org.icefaces.ace.component.menu.AbstractMenu
      - - org.icefaces.ace.component.menubutton.MenuButtonBase

- All Implemented Interfaces:
    java.util.EventListener, javax.faces.component.PartialStateHolder, javax.faces.component.StateHolder, javax.faces.component.TransientStateHolder, javax.faces.event.ComponentSystemEventListener, javax.faces.event.FacesListener, javax.faces.event.SystemEventListenerHolder, IMenuButton
  Direct Known Subclasses:
    MenuButton

      public abstract class MenuButtonBase
      extends AbstractMenu
      implements IMenuButton

  MenuButton displays different commands in a popup menu.

  For more information, see the MenuButton Wiki Documentation.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `MenuButtonBase.PropertyKeys`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `COMPONENT_TYPE`
    `static java.lang.String` | `RENDERER_TYPE`

    - ### Fields inherited from class javax.faces.component.UIComponent

      `ATTRS_WITH_DECLARED_DEFAULT_VALUES, BEANINFO_KEY, bindings, COMPOSITE_COMPONENT_TYPE_KEY, COMPOSITE_FACET_NAME, CURRENT_COMPONENT, CURRENT_COMPOSITE_COMPONENT, FACETS_KEY, HONOR_CURRENT_COMPONENT_ATTRIBUTES_PARAM_NAME, VIEW_LOCATION_KEY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MenuButtonBase()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getAccesskey()` Return the value of the `accesskey` property.
    `java.lang.String` | `getEffect()` Return the value of the `effect` property.
    `int` | `getEffectDuration()` Return the value of the `effectDuration` property.
    `java.lang.String` | `getFamily()`
    `java.lang.Integer` | `getForceUpdateCounter()` Return the value of the `forceUpdateCounter` property.
    `MenuModel` | `getModel()` Return the value of the `model` property.
    `java.lang.String` | `getStyle()` Return the value of the `style` property.
    `java.lang.String` | `getStyleClass()` Return the value of the `styleClass` property.
    `java.lang.String` | `getValue()` Return the value of the `value` property.
    `java.lang.String` | `getWidgetVar()` Return the value of the `widgetVar` property.
    `int` | `getZindex()` Return the value of the `zindex` property.
    `boolean` | `isDisabled()` Return the value of the `disabled` property.
    `java.lang.Boolean` | `isForceMenuUpdate()` Return the value of the `forceMenuUpdate` property.
    `protected boolean` | `isPropertySet(java.lang.String finder)`
    `void` | `setAccesskey(java.lang.String accesskey)` Set the value of the `accesskey` property.
    `void` | `setDisabled(boolean disabled)` Set the value of the `disabled` property.
    `void` | `setEffect(java.lang.String effect)` Set the value of the `effect` property.
    `void` | `setEffectDuration(int effectDuration)` Set the value of the `effectDuration` property.
    `void` | `setForceMenuUpdate(java.lang.Boolean forceMenuUpdate)` Set the value of the `forceMenuUpdate` property.
    `void` | `setForceUpdateCounter(java.lang.Integer forceUpdateCounter)` Set the value of the `forceUpdateCounter` property.
    `void` | `setModel(MenuModel model)` Set the value of the `model` property.
    `void` | `setStyle(java.lang.String style)` Set the value of the `style` property.
    `void` | `setStyleClass(java.lang.String styleClass)` Set the value of the `styleClass` property.
    `void` | `setValue(java.lang.String value)` Set the value of the `value` property.
    `void` | `setValueExpression(java.lang.String name, javax.el.ValueExpression binding)`
    `void` | `setWidgetVar(java.lang.String widgetVar)` Set the value of the `widgetVar` property.
    `void` | `setZindex(int zindex)` Set the value of the `zindex` property.

    - ### Methods inherited from class org.icefaces.ace.component.menu.AbstractMenu

      `buildMenuFromModel, isBuiltFromModel, isDynamic, markAsBuiltFromModel, processDecodes, setTransientRecursive, shouldBuildFromModel`

    - ### Methods inherited from class javax.faces.component.UIComponentBase

      `addClientBehavior, addFacesListener, broadcast, clearInitialState, decode, encodeBegin, encodeChildren, encodeEnd, findComponent, getAttributes, getChildCount, getChildren, getClientBehaviors, getClientId, getDefaultEventName, getEventNames, getFacesContext, getFacesListeners, getFacet, getFacetCount, getFacets, getFacetsAndChildren, getId, getListenersForEventClass, getParent, getRenderer, getRendererType, getRendersChildren, getValueBinding, invokeOnComponent, isRendered, isTransient, markInitialState, processRestoreState, processSaveState, processUpdates, processValidators, queueEvent, removeFacesListener, restoreAttachedState, restoreState, saveAttachedState, saveState, setId, setParent, setRendered, setRendererType, setTransient, setValueBinding, subscribeToEvent, unsubscribeFromEvent`

    - ### Methods inherited from class javax.faces.component.UIComponent

      `encodeAll, getClientId, getCompositeComponentParent, getContainerClientId, getCurrentComponent, getCurrentCompositeComponent, getNamingContainer, getResourceBundleMap, getStateHelper, getStateHelper, getTransientStateHelper, getTransientStateHelper, getValueExpression, initialStateMarked, isCompositeComponent, isInView, isVisitable, popComponentFromEL, processEvent, pushComponentToEL, restoreTransientState, saveTransientState, setInView, visitTree`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### COMPONENT_TYPE

          public static final java.lang.String COMPONENT_TYPE

      See Also:
        Constant Field Values

    - #### RENDERER_TYPE

          public static final java.lang.String RENDERER_TYPE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### MenuButtonBase

          public MenuButtonBase()

  - ### Method Detail

    - #### getFamily

          public java.lang.String getFamily()

      Specified by:
        `getFamily` in class `javax.faces.component.UIComponent`

    - #### setAccesskey

          public void setAccesskey(java.lang.String accesskey)

      Set the value of the `accesskey` property.

      Contents: Access key that, when pressed, activates this component.

      Specified by:
        `setAccesskey` in interface `IMenuButton`

    - #### getAccesskey

          public java.lang.String getAccesskey()

      Return the value of the `accesskey` property.

      Contents: Access key that, when pressed, activates this component.

      Specified by:
        `getAccesskey` in interface `IMenuButton`

    - #### setDisabled

          public void setDisabled(boolean disabled)

      Set the value of the `disabled` property.

      Contents: Disables or enables the button.

      Specified by:
        `setDisabled` in interface `IMenuButton`

    - #### isDisabled

          public boolean isDisabled()

      Return the value of the `disabled` property.

      Contents: Disables or enables the button.

      Specified by:
        `isDisabled` in interface `IMenuButton`

    - #### setEffect

          public void setEffect(java.lang.String effect)

      Set the value of the `effect` property.

      Contents: Sets the effect for the menu display, default value is FADE. Possible values are "FADE", "SLIDE", "NONE". Use "NONE" to disable animation at all.

      Specified by:
        `setEffect` in interface `IMenuButton`

    - #### getEffect

          public java.lang.String getEffect()

      Return the value of the `effect` property.

      Contents: Sets the effect for the menu display, default value is FADE. Possible values are "FADE", "SLIDE", "NONE". Use "NONE" to disable animation at all. Default = 'fade'.

      Specified by:
        `getEffect` in interface `IMenuButton`

    - #### setEffectDuration

          public void setEffectDuration(int effectDuration)

      Set the value of the `effectDuration` property.

      Contents: Sets the effect duration in milliseconds.

      Specified by:
        `setEffectDuration` in interface `IMenuButton`

    - #### getEffectDuration

          public int getEffectDuration()

      Return the value of the `effectDuration` property.

      Contents: Sets the effect duration in milliseconds. Default = '400'.

      Specified by:
        `getEffectDuration` in interface `IMenuButton`

    - #### setForceMenuUpdate

          public void setForceMenuUpdate(java.lang.Boolean forceMenuUpdate)

      Set the value of the `forceMenuUpdate` property.

      Contents: Set to true when the entire menu needs to be updated in the client, such as when an individual menu item changes label or styling, and the entire menu needs to be reinitialized in the client in order to get all the styling and behaviour re-applied to the new HTML nodes. The value of this attribute will be automatically set to false by the component after consuming it (if applicable).

      Specified by:
        `setForceMenuUpdate` in interface `IMenuButton`

    - #### isForceMenuUpdate

          public java.lang.Boolean isForceMenuUpdate()

      Return the value of the `forceMenuUpdate` property.

      Contents: Set to true when the entire menu needs to be updated in the client, such as when an individual menu item changes label or styling, and the entire menu needs to be reinitialized in the client in order to get all the styling and behaviour re-applied to the new HTML nodes. The value of this attribute will be automatically set to false by the component after consuming it (if applicable). Default = 'false'.

      Specified by:
        `isForceMenuUpdate` in interface `IMenuButton`

    - #### setModel

          public void setModel(MenuModel model)

      Set the value of the `model` property.

      Contents: MenuModel instance to create menus programmatically. For the menuitem and submenu components, use explicit ids, and avoid long processing in the getter method for this property, as it will be called multiple times, in every lifecycle. If using MyFaces, see wiki page for some known issues.

      Specified by:
        `setModel` in interface `IMenuButton`

    - #### getModel

          public MenuModel getModel()

      Return the value of the `model` property.

      Contents: MenuModel instance to create menus programmatically. For the menuitem and submenu components, use explicit ids, and avoid long processing in the getter method for this property, as it will be called multiple times, in every lifecycle. If using MyFaces, see wiki page for some known issues.

      Specified by:
        `getModel` in interface `IMenuButton`
      Specified by:
        `getModel` in class `AbstractMenu`

    - #### setStyle

          public void setStyle(java.lang.String style)

      Set the value of the `style` property.

      Contents: Style of the main container element.

      Specified by:
        `setStyle` in interface `IMenuButton`

    - #### getStyle

          public java.lang.String getStyle()

      Return the value of the `style` property.

      Contents: Style of the main container element.

      Specified by:
        `getStyle` in interface `IMenuButton`

    - #### setStyleClass

          public void setStyleClass(java.lang.String styleClass)

      Set the value of the `styleClass` property.

      Contents: Style class of the main container element.

      Specified by:
        `setStyleClass` in interface `IMenuButton`

    - #### getStyleClass

          public java.lang.String getStyleClass()

      Return the value of the `styleClass` property.

      Contents: Style class of the main container element.

      Specified by:
        `getStyleClass` in interface `IMenuButton`

    - #### setValue

          public void setValue(java.lang.String value)

      Set the value of the `value` property.

      Contents: Label of the button.

      Specified by:
        `setValue` in interface `IMenuButton`

    - #### getValue

          public java.lang.String getValue()

      Return the value of the `value` property.

      Contents: Label of the button.

      Specified by:
        `getValue` in interface `IMenuButton`

    - #### setWidgetVar

          public void setWidgetVar(java.lang.String widgetVar)

      Set the value of the `widgetVar` property.

      Contents: Javascript variable name of the wrapped widget.

      Specified by:
        `setWidgetVar` in interface `IMenuButton`

    - #### getWidgetVar

          public java.lang.String getWidgetVar()

      Return the value of the `widgetVar` property.

      Contents: Javascript variable name of the wrapped widget.

      Specified by:
        `getWidgetVar` in interface `IMenuButton`

    - #### setZindex

          public void setZindex(int zindex)

      Set the value of the `zindex` property.

      Contents: zindex property to control overlapping with other elements.

      Specified by:
        `setZindex` in interface `IMenuButton`

    - #### getZindex

          public int getZindex()

      Return the value of the `zindex` property.

      Contents: zindex property to control overlapping with other elements. Default = '1'.

      Specified by:
        `getZindex` in interface `IMenuButton`

    - #### setForceUpdateCounter

          public void setForceUpdateCounter(java.lang.Integer forceUpdateCounter)

      Set the value of the `forceUpdateCounter` property.

      Specified by:
        `setForceUpdateCounter` in interface `IMenuButton`

    - #### getForceUpdateCounter

          public java.lang.Integer getForceUpdateCounter()

      Return the value of the `forceUpdateCounter` property.

      Specified by:
        `getForceUpdateCounter` in interface `IMenuButton`

    - #### isPropertySet

          protected boolean isPropertySet(java.lang.String finder)

    - #### setValueExpression

          public void setValueExpression(java.lang.String name,
                                         javax.el.ValueExpression binding)

      Overrides:
        `setValueExpression` in class `javax.faces.component.UIComponent`

Copyright 2025 ICEsoft Technologies Canada, Corp. All Rights Reserved.